/*************************************************************************
Title........ serialmod.h
Date......... Tue Jul 20 15:12:12  1999
Author....... J.M.Tarrant
*************************************************************************/

/****	Defines */
/* Output port pin assignments
 All other registers are defined locally*/

	#define	SERA_BASE	(SIM40_BASE+0x700)

	#define	SER_OP4S	REGB(SERA_BASE+0x1E)
	#define	SER_OP4C	REGB(SERA_BASE+0x1F)

	#define SFX1_S1		0x10
	#define SFX1_S2		0x40


/* Mode register 1 bits */
	#define	PARITYEVEN	0x00
	#define	PARITYODD	0x04
	#define	PARITYNONE	0x10
	#define	PARITYBITS	0x1c

	#define	BITS6		0x01
	#define	BITS7		0x02
	#define	BITS8		0x03
	#define	CHARBITS	0x03

	#define RXRTS		0x80
	#define RXNONE		0x00
	#define RXBITS		0x80

/* Mode register 2 bits */
	#define	STOP1		0x07
	#define	STOP2		0x0f
	#define	STOPBITS	0x0f

	#define	TXRTS		0x20
	#define	TXCTS		0x10
	#define	TXNONE		0x00
	#define	TXBITS		0x30

/* Auxiliary control register */
	#define	BAUDSET1	0x00
	#define	BAUDSET2	0x80
	#define	BAUDSETBITS	0x80

/* Baud select */
	#define	BAUD50		0
	#define	BAUD75		1
	#define	BAUD110		2
	#define	BAUD134		3
	#define	BAUD150		4
	#define	BAUD200		5
	#define	BAUD300		6
	#define	BAUD600		7
	#define	BAUD1050	8
	#define	BAUD1200	9
	#define BAUD1800	10
	#define	BAUD2000	11
	#define	BAUD2400	12
	#define	BAUD4800	13
	#define	BAUD7200	14
	#define	BAUD9600	15
	#define	BAUD19200	16
	#define	BAUD38400	17
	#define	BAUD76800	18

/****	Type Definitions */
typedef	struct	serialvars
		{
		WORD	txain;
		WORD	txaout;
		WORD	rxain;
		WORD	rxaout;

		WORD	txbin;
		WORD	txbout;
		WORD	rxbin;
		WORD	rxbout;
		BYTE	base;
		} SERIALVARS;

typedef	struct serialservices
	{
	BYTE	(*configure)(const DEVICE* dev,BYTE txbaud,BYTE rxbaud,BYTE data,BYTE stop,BYTE parity,BYTE txhs ,BYTE rxhs);
	BYTE	(*tx)(const DEVICE* dev,char ch);
	WORD	(*rx)(const DEVICE* dev);
	BYTE 	(*txempty)(const DEVICE* dev);
	BYTE 	(*rxempty)(const DEVICE* dev);
	void 	(*cleartx)(const DEVICE* dev);
	void 	(*clearrx)(const DEVICE* dev);
	} SERIALSERVICES;

typedef	struct	serialcfg
	{
	WORD	mcr;
	BYTE	ivr;
	BYTE	ilr;
	BYTE	ier;
	BYTE	acr;
	BYTE	opcr;

	BYTE		txbauda;
	BYTE		rxbauda;
	BYTE		bitsa;
	BYTE		stopa;
	BYTE		paritya;
	BYTE		txhsa;
	BYTE		rxhsa;

	BYTE		txbaudb;
	BYTE		rxbaudb;
	BYTE		bitsb;
	BYTE		stopb;
	BYTE		parityb;
	BYTE		txhsb;
	BYTE		rxhsb;
	} SERIALCFG;


/****	Prototypes */

	#include	"serialmod.p"

/*************************************************************************/
