/*************************************************************************
Title........ sim40.h
Date......... 05/07/99
Author....... J.M.Tarrant
*************************************************************************/

/****	Defines */

	#define	SIM40_BASE	0xFFFFF000
	#define	PORTA		REGB(SIM40_BASE+0x11)
	#define	PORTB		REGB(SIM40_BASE+0x019)
	#define	PICR		REGW(SIM40_BASE+0x22)
	#define	DDRA		REGB(SIM40_BASE+0x13)
	#define PPARA1		REGB(SIM40_BASE+0x15)
	#define	POPSET		REGB(SIM40_BASE+0x71E)
	#define	POPCLR		REGB(SIM40_BASE+0x71F)

/*  port A bits */
	#define		PA_SFX1RESET		0x01
	#define		PA_SFX2RESET		0x02
	#define		PA_LED				0x04
	#define		PA_BTN				0x08
	#define		PA_I2CSCL			0x10
	#define		PA_I2CSDA 			0x20
	#define		PA_SFX2S1			0x40
	#define		PA_SFX2S2			0x80


/*	port B bits */
	#define		PB_RESET 	0x01		/* reset line - active 0 */
	#define		PB_CS1	 	0x02
	#define		PB_CS2	 	0x04
	#define		PB_CURRENT 	0x08
	#define		PB_CS3	 	0x10
	#define		PB_IRQ5	 	0x20
	#define		PB_IRQ6	 	0x40
	#define		PB_IRQ7 	0x80		/* power fail interrupt	*/


/****	Type Definitions */

typedef	struct
	{
	WORD	mcr;			/* MCR */
	BYTE	sypcr;			/* SYPCR */
	BYTE	gap1;			/* EVEN ADDRESS */
	WORD	syncr;			/* SYNCR */
	LONG	cs0mask;		/* CS0 ADR MASK   */
	LONG	cs0base;		/* CS0 BASE ADR   */
	LONG	cs1mask;		/* CS1 ADR MASK   */
	LONG	cs1base;		/* CS1 BASE ADR   */
	LONG	cs2mask;		/* CS2 ADR MASK   */
	LONG	cs2base;		/* CS2 BASE ADR   */
	LONG	cs3mask;		/* CS3 ADR MASK   */
	LONG	cs3base;		/* CS3 BASE ADR   */
	BYTE	avr;			/* AVR */
	BYTE	swiv;			/* SWIV */
	WORD	picr;			/* PICR */
	WORD	pitr;			/* PITR */
	BYTE	portA;			/* PORTA */
	BYTE	ppara1;			/* PPARA1 */
	BYTE	ppara2;			/* PPARA2 */
	BYTE	ddra;			/* DDRA */
	BYTE	portB;			/* PORTB */
	BYTE	pparb;			/* PPARB */
	BYTE	ddrb;			/* DDRB */
	} SIM40CFG;






/****	Prototypes */
/*************************************************************************/
