/*************************************************************************
Title........ sounddev.h
Date......... Wed Jul 14 10:11:03  1999
Author....... J.M.Tarrant
*************************************************************************/

/****	Defines */


	#define		_4KHZ			0
	#define		_8KHZ			1
	#define		_16KHZ			2
	#define		_32KHZ			3

	#define	EOF_SAMPLES		(SAMPLE*)			0x00000000
	#define	RST_SAMPLES		(SAMPLE*)			0x00000001
	#define	REWIND			(SAMPLE*)			0x80000000
	#define	REWIND1			(SAMPLE*)			0x80000001
	#define	REWIND2			(SAMPLE*)			0x80000002
	#define	REWIND3			(SAMPLE*)			0x80000003
	#define	REWIND4			(SAMPLE*)			0x80000004
	#define	REWIND5			(SAMPLE*)			0x80000005
	#define	REWIND6			(SAMPLE*)			0x80000006
	#define	REWIND7			(SAMPLE*)			0x80000007
	#define	REWIND8			(SAMPLE*)			0x80000008
	#define	REWIND9			(SAMPLE*)			0x80000009
	#define	REWINDa			(SAMPLE*)			0x8000000a
	#define	REWINDb			(SAMPLE*)			0x8000000b
	#define	REWINDc			(SAMPLE*)			0x8000000c
	#define	REWINDd			(SAMPLE*)			0x8000000d
	#define	REWINDe			(SAMPLE*)			0x8000000e
	#define	REWINDf			(SAMPLE*)			0x8000000f

/****	Type Definitions */

typedef	enum
	{
	CH2SPK2,
	CH1SPK2
	} MODE;

typedef	struct samdata
		{
		WORD	frequency;		/* this one not used */
		LONG	size;
		LONG	start;
		} SAMDATA;

typedef	struct sample
		{
		WORD		frequency;
		const SAMDATA*	samdata;
		} SAMPLE;

typedef	struct	chzvars
	{
	const SAMPLE*const*	tuneptr;
	WORD				idx;
	BYTE				volume;
	BYTE				tunevolume;
	} CHZVARS;


typedef	struct	soundvars
	{
	BYTE	mode;
	} SOUNDVARS;

typedef	struct	soundzvars
	{
	CHZVARS		Ch1;
	CHZVARS		Ch2;
	} SOUNDZVARS;

typedef	struct soundcfg
	{
	BYTE	defvol1;
	BYTE	defvol2;
	BYTE	mode;
	} SOUNDCFG;


typedef	struct	soundservices
	{
	void	(*playback)(const SAMPLE*const* t, BYTE v);
	void	(*quiet)();
	void	(*setvolume)(UBYTE v);
	BYTE	(*soundbusy)();
	} SOUNDSERVICES;

/****	Prototypes */

	#include	"sounddev.p"

/*************************************************************************/
